'****************************************************************
'*  Name    : CAN_QUE_INC.INC                                   *
'*  Author  : Bobby Garrett                                     *
'*  Notice  : Copyright (c) 2012 Bobby Garrett                  *
'*          : All Rights Reserved                               *
'*  Date    : 21/08/2012                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************

'****************************************************************            
'* Variables for CAN queue                                      *
'**************************************************************** 
   '     Dim DUMMY As Byte           'Pad out for boundary crossing

 'Six outbound queues
        Dim QOUT1_MSGID_DATA As Dword
        Dim QOUT1_MSGID_TYPE As Byte
        Dim QOUT1_DATA_LEN As Byte
        Dim QOUT1[8] As Byte
                
        Dim QOUT2_MSGID_DATA As Dword
        Dim QOUT2_MSGID_TYPE As Byte
        Dim QOUT2_DATA_LEN As Byte
        Dim QOUT2[8] As Byte

        Dim QOUT3_MSGID_DATA As Dword
        Dim QOUT3_MSGID_TYPE As Byte
        Dim QOUT3_DATA_LEN As Byte
        Dim QOUT3[8] As Byte

        Dim QOUT4_MSGID_DATA As Dword
        Dim QOUT4_MSGID_TYPE As Byte        
        Dim QOUT4_DATA_LEN As Byte
        Dim QOUT4[8] As Byte
        
        Dim QOUT5_MSGID_DATA As Dword
        Dim QOUT5_MSGID_TYPE As Byte
        Dim QOUT5_DATA_LEN As Byte
        Dim QOUT5[8] As Byte

        Dim QOUT6_MSGID_DATA As Dword
        Dim QOUT6_MSGID_TYPE As Byte
        Dim QOUT6_DATA_LEN As Byte
        Dim QOUT6[8] As Byte

        Dim QOUT[8] As Byte
        
        Dim LOAD_Q_POS As Byte
        Dim UNLOAD_Q_POS As Byte
        Dim Q_LENGTH As Byte
        
        Dim tempB1 As Byte  
        
'**************************************************************** 
'Process for outbound transmission queue                        *
'**************************************************************** 

' Implementation example
' MSGID_DATA = 2
' MSGID_TYPE = STD  
' DATA length / DATA x 8 bytes
' There must always be 8 DATA bytes even if length is 1 (pad out with zeroes)
' Zero length messages are not allowed here, see CAN_SEND_FAST sub !!Not strictly true now
' GoSub INSERT_IN_Q[8,0x12,0x04,0x18,0x02,0xff,0x00,0x00,0x00]
' or
' GoSub INSERT_IN_Q[8,SPEED,RPM,0x00,0x00,0x00,0x00,0x00,0x00]       

INSERT_IN_Q:

        If Q_LENGTH > 5 Then Return       'Queue is full '!!Note!! log to EEPROM to see how many times this occurs
        Inc LOAD_Q_POS                    'Get the next queue location
        If LOAD_Q_POS > 6 Then LOAD_Q_POS = 1  'Wrap around to the start

        Pop MSGID_TYPE 
        Pop MSGID_DATA 
    
        Pop QOUT[7]
        Pop QOUT[6]
        Pop QOUT[5]
        Pop QOUT[4]
        Pop QOUT[3]
        Pop QOUT[2]
        Pop QOUT[1]
        Pop QOUT[0]
        Pop tempB1
        
        Select LOAD_Q_POS                 'Determine where in queue to store the message

Case 1           
        QOUT1_MSGID_TYPE = MSGID_TYPE 
        QOUT1_MSGID_DATA = MSGID_DATA             
        QOUT1[7] = QOUT[7]
        QOUT1[6] = QOUT[6]
        QOUT1[5] = QOUT[5]
        QOUT1[4] = QOUT[4]
        QOUT1[3] = QOUT[3]
        QOUT1[2] = QOUT[2]
        QOUT1[1] = QOUT[1]
        QOUT1[0] = QOUT[0]
        QOUT1_DATA_LEN = tempB1

Case 2        
        QOUT2_MSGID_TYPE = MSGID_TYPE 
        QOUT2_MSGID_DATA = MSGID_DATA             
        QOUT2[7] = QOUT[7]
        QOUT2[6] = QOUT[6]
        QOUT2[5] = QOUT[5]
        QOUT2[4] = QOUT[4]
        QOUT2[3] = QOUT[3]
        QOUT2[2] = QOUT[2]
        QOUT2[1] = QOUT[1]
        QOUT2[0] = QOUT[0]
        QOUT2_DATA_LEN = tempB1  
           
Case 3
        QOUT3_MSGID_TYPE = MSGID_TYPE 
        QOUT3_MSGID_DATA = MSGID_DATA             
        QOUT3[7] = QOUT[7]
        QOUT3[6] = QOUT[6]
        QOUT3[5] = QOUT[5]
        QOUT3[4] = QOUT[4]
        QOUT3[3] = QOUT[3]
        QOUT3[2] = QOUT[2]
        QOUT3[1] = QOUT[1]
        QOUT3[0] = QOUT[0]
        QOUT3_DATA_LEN = tempB1 

Case 4         
        QOUT4_MSGID_TYPE = MSGID_TYPE 
        QOUT4_MSGID_DATA = MSGID_DATA             
        QOUT4[7] = QOUT[7]
        QOUT4[6] = QOUT[6]
        QOUT4[5] = QOUT[5]
        QOUT4[4] = QOUT[4]
        QOUT4[3] = QOUT[3]
        QOUT4[2] = QOUT[2]
        QOUT4[1] = QOUT[1]
        QOUT4[0] = QOUT[0]
        QOUT4_DATA_LEN = tempB1 
        
Case 5
        QOUT5_MSGID_TYPE = MSGID_TYPE 
        QOUT5_MSGID_DATA = MSGID_DATA             
        QOUT5[7] = QOUT[7]
        QOUT5[6] = QOUT[6]
        QOUT5[5] = QOUT[5]
        QOUT5[4] = QOUT[4]
        QOUT5[3] = QOUT[3]
        QOUT5[2] = QOUT[2]
        QOUT5[1] = QOUT[1]
        QOUT5[0] = QOUT[0]
        QOUT5_DATA_LEN = tempB1  
        
Case 6
        QOUT6_MSGID_TYPE = MSGID_TYPE 
        QOUT6_MSGID_DATA = MSGID_DATA             
        QOUT6[7] = QOUT[7]
        QOUT6[6] = QOUT[6]
        QOUT6[5] = QOUT[5]
        QOUT6[4] = QOUT[4]
        QOUT6[3] = QOUT[3]
        QOUT6[2] = QOUT[2]
        QOUT6[1] = QOUT[1]
        QOUT6[0] = QOUT[0]
        QOUT6_DATA_LEN = tempB1

EndSelect
        Inc Q_LENGTH
        'Note - send out to serial port message data and queue length etc for testing
    
        Return           

