'****************************************************************
'*  Name    : CAN_SEND_INC.INC                                  *
'*  Author  : Bobby Garrett                                     *
'*  Notice  : Copyright (c) 2012 Bobby Garrett                  *
'*          : All Rights Reserved                               *
'*  Date    : 21/08/2012                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************

'**************************************************************** 
'Process CAN output on interval from ISR. One TX per call.      *
'****************************************************************     
CAN_SEND:

        HRSOut "Node 1 TX Q Routine Q_LENGTH = ",Dec Q_LENGTH,10,10, 13
        If Q_LENGTH = 0 Then 
        TX_QUEUE_UPDATE_REQ_COUNTER = 0   'Nothing to TX - Reset the interval counter              
        Return                            'and return
        EndIf
    
'If all nodes are busy just hold off for now  '!!Note!! log to EEPROM to see how many times this occurs
        If TXB0CON.3 = 1 And TXB1CON.3 = 1 And TXB2CON.3 = 1 Then
        HRSOut "Node 1 TX Q Routine FULL",10,10, 13
        Return
        EndIf
        HRSOut "Node 1 TX Q Routine",10,10, 13
        Toggle TX_LED   'Flash LED - let me know it is transmitting    
    
'Run through buffer circularly.
        Inc UNLOAD_Q_POS                  'Get the next queue location
        If UNLOAD_Q_POS > 6 Then UNLOAD_Q_POS = 1    'Wrap around to the start
                HRSOut "Node 1 TX Q Routine",Dec UNLOAD_Q_POS, 10,10, 13
        Select  UNLOAD_Q_POS              'Determine which message to be sent

Case 1
        HRSOut "Node 1 TX Case 1_1", 10,10, 13
        CANSetMsgID [QOUT1_MSGID_DATA,QOUT1_MSGID_TYPE] 
        HRSOut "Node 1 TX Case 1_2", 10,10, 13
        CANSendMessage [QOUT1,QOUT1_DATA_LEN,CAN_TX_PRIORITY_0 & CAN_TX_NO_RTR_FRAME,CAN_TX_OK]
        HRSOut "Node 1 TX Case 1_3", 10,10, 13
Case 2
        CANSetMsgID [QOUT2_MSGID_DATA,QOUT2_MSGID_TYPE]     
        CANSendMessage [QOUT2,QOUT2_DATA_LEN,CAN_TX_PRIORITY_0 & CAN_TX_NO_RTR_FRAME,CAN_TX_OK]
    
Case 3
        CANSetMsgID [QOUT3_MSGID_DATA,QOUT3_MSGID_TYPE]     
        CANSendMessage [QOUT3,QOUT3_DATA_LEN,CAN_TX_PRIORITY_0 & CAN_TX_NO_RTR_FRAME,CAN_TX_OK]

Case 4
        CANSetMsgID [QOUT4_MSGID_DATA,QOUT4_MSGID_TYPE]     
        CANSendMessage [QOUT4,QOUT4_DATA_LEN,CAN_TX_PRIORITY_0 & CAN_TX_NO_RTR_FRAME,CAN_TX_OK]
  
Case 5
        CANSetMsgID [QOUT5_MSGID_DATA,QOUT5_MSGID_TYPE]     
        CANSendMessage [QOUT5,QOUT5_DATA_LEN,CAN_TX_PRIORITY_0 & CAN_TX_NO_RTR_FRAME,CAN_TX_OK]

Case 6
        CANSetMsgID [QOUT6_MSGID_DATA,QOUT6_MSGID_TYPE]     
        CANSendMessage [QOUT6,QOUT6_DATA_LEN,CAN_TX_PRIORITY_0 & CAN_TX_NO_RTR_FRAME,CAN_TX_OK]

EndSelect

        Dec Q_LENGTH            '1 less to TX
        'Note - send out to serial port message data and queue length etc for testing
       
        If Q_LENGTH = 0 Then    'If there is nothing in the queue
        LOAD_Q_POS = 0          'Re-synch the load and unload pointers
        UNLOAD_Q_POS = 0        'in case they have gone out of synch
        EndIf
        
        TX_QUEUE_UPDATE_REQ_COUNTER = 0
        HRSOut "Node 1 TX End", 10,10, 13    
        Return

